from flask import Flask, request, jsonify
import joblib
import traceback
import pandas as pd
import numpy as np

# Your API definition
app = Flask(__name__)

@app.route('/predict', methods=['POST'])
def predict():
    if lr:
        try:
            json_ = request.json
            query = pd.DataFrame(json_)
            query = query.reindex(columns=model_columns, fill_value=0)
            prediction = list(lr.predict(query))
            predict_prob = list(lr.predict_proba(query)[:,1])
            return jsonify({'predicted class': str(prediction), 'probability of default': str(predict_prob)})


        except:

            return jsonify({'trace': traceback.format_exc()})
    else:
        print ('Train the model first')
        return ('No model here to use')

if __name__ == '__main__':
    # try:
    #     port = int(sys.argv[1]) # This is for a command-line input
    # except:
    #     port = 5000 # If you don't provide any port the port will be set to 12345
    lr = joblib.load("model.joblib")
    model_columns = joblib.load("model_columns.joblib")
    app.run(host='0.0.0.0', debug=True)
